#include "gtest/gtest.h"
#include <gtest/gtest.h>
#include <stdio.h>
#include <string>

#define TESTING

#include "main.c"

void stream_add(FILE *stream, std::string string) {
  fprintf(stream, "%s", string.c_str());
  fseek(stream, -string.length(), SEEK_CUR);
}

class Trebuchet : public ::testing::Test {
public:
  FILE *input;

  Trebuchet() {}

  ~Trebuchet() {}

  void SetUp() {
    input = tmpfile();
    if (input == NULL) {
      fprintf(stderr, "Error creating tmpfile\n");
      fprintf(stderr, "Error: %s\n", strerror(errno));
      exit(1);
    }
  }

  void TearDown() {}
};

TEST_F(Trebuchet, AssignmentInput) {
  testing::internal::CaptureStdout();
  stream_add(input, "1abc2\npqr3stu8vwx\na1b2c3d4e5f\ntreb7uchet");
  char* argv[2];
  mainTest(input, 1, argv);
  std::string output = testing::internal::GetCapturedStdout();
  // Check the output of the program.
  EXPECT_EQ("The sum of the calibration values is 142\n", output);
}

TEST_F(Trebuchet, getVal) {
  EXPECT_EQ(12, getVal((char *)"1abc2"));
  EXPECT_EQ(38, getVal((char *)"pqr3stu8vwx"));
  EXPECT_EQ(15, getVal((char *)"a1b2c3d4e5f"));
  EXPECT_EQ(77, getVal((char *)"treb7uchet"));
}
